/* -----------------------------------------------------------------------------
 *
 *  Copyright (C) 2009  Anna Yershova, Swati Jain, 
 *                      Steven M. LaValle, Julie C. Mitchell
 *
 *
 *  This file is part of the Incremental Successive Orthogonal Images (ISOI)
 *
 *  ISOI is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  ISOI is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this software; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *  For more information about ISOI see http://rotations.mitchell-lab.org/
 *
 *----------------------------------------------------------------------------- */

#include"s2_sequence.h"

vector < double >find_point(int base_grid, long int point,long int level,long int healpix_point)
{
	int position=point%4;
	long int quo=0;
	double theta=0,phi=0;
	double vec[3];
	vector <double> Point;
	if(base_grid == 6 or base_grid == 7)
	{
		switch(position)//this switch statement translates between sequence of healpix and sequence for uniform points 
		{
			case 0:
				healpix_point+=3;
				break;
			case 1:
				healpix_point+=0;
				break;
			case 2: 
				healpix_point+=2;
				break;
			case 3:
				healpix_point+=1;
				break;
		}	
	}
	else if(base_grid == 3 or base_grid == 1 or base_grid == 9 or base_grid == 11)
	{
		switch(position)//this switch statement translates between sequence of healpix and sequence for uniform points 
		{
			case 0:
				healpix_point+=3;
				break;
			case 1:
				healpix_point+=0;
				break;
			case 2: 
				healpix_point+=1;
				break;
			case 3:
				healpix_point+=2;
				break;
		}	
	}
	else if(base_grid == 2 or base_grid == 0 or base_grid == 8 or base_grid == 10)
	{
		switch(position)//this switch statement translates between sequence of healpix and sequence for uniform points 
		{
			case 0:
				healpix_point+=0;
				break;
			case 1:
				healpix_point+=3;
				break;
			case 2: 
				healpix_point+=1;
				break;
			case 3:
				healpix_point+=2;
				break;
		}	
	}
	else if(base_grid == 4 or base_grid == 5)
	{
		switch(position)//this switch statement translates between sequence of healpix and sequence for uniform points 
		{
			case 0:
				healpix_point+=0;
				break;
			case 1:
				healpix_point+=3;
				break;
			case 2: 
				healpix_point+=2;
				break;
			case 3:
				healpix_point+=1;
				break;
		}	
	}

	quo=point/4;
	if(quo==0)
	{
		long int nside=pow(2,level);
		pix2ang_nest(nside,healpix_point,&theta,&phi);
		ang2vec(theta,phi,vec);
		Point.resize(0);
		Point.push_back(vec[0]);	
		Point.push_back(vec[1]);	
		Point.push_back(vec[2]);
		return Point;
	}
	else
	{
		return find_point(base_grid,quo-1,level+1,4*healpix_point);
	}
}	
		
