/* -----------------------------------------------------------------------------
 *
 *  Copyright (C) 2009  Anna Yershova, Swati Jain, 
 *                      Steven M. LaValle, Julie C. Mitchell
 *
 *
 *  This file is part of the Incremental Successive Orthogonal Images (ISOI)
 *
 *  ISOI is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  ISOI is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this software; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *  For more information about ISOI see http://rotations.mitchell-lab.org/
 *
 *----------------------------------------------------------------------------- */

#include"s2_sequence.h"

int main()
{
	long int num_points=0;
	int num;
	vector < double > Points;
	vector <int> Sequence_base;
	ifstream input;
	ofstream output;
	int limit=0;
	double theta=0,phi=0;
	double vec[3];
	long int base_grid=0,cur_point=0;
	long int point_healpix=0;
	char filename[50];

	cout << "Enter number of points in the sequence: ";
	cin >> num_points;
	cout << "Enter the filename in which sequence of the base grid is there: ";
	cin >> filename;
	
	input.open(filename);
	Sequence_base.resize(0);
	while(!input.eof())
	{
		input >> num;
		Sequence_base.push_back(num);
	}
	input.close();
	Sequence_base.pop_back();
		
	//first twelve points are the base grid points;
	output.open("data.pts");
	if(num_points<12)
		limit=num_points;
	else
		limit=12;
	for(int i=0;i<limit;i++)
	{
		pix2ang_nest(1,Sequence_base[i],&theta,&phi);
		cout << theta*180/M_PI << " " << phi*180/M_PI << endl; 
//                ang2vec(theta,phi,vec);
//		output << vec[0] << "\t" << vec[1] << "\t" << vec[2] << endl;
	}

	for(int i=0;i<num_points-12;i++)
	{
		Points.resize(0);
		base_grid=i%12;
		cur_point=i/12;
		point_healpix=4*Sequence_base[base_grid];
		Points=find_point(Sequence_base[base_grid],cur_point,1,point_healpix); //current point value,level,current point in healpix
		output << Points[0] << "\t" << Points[1] << "\t" << Points[2] << endl;
	}
	output.close();
	return 0;
}
	
